/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.http;

import com.microsoft.rest.ServiceCall;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceException;
import com.microsoft.rest.ServiceResponse;
import fixtures.http.models.ErrorException;
import java.io.IOException;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in HttpFailures.
 */
public interface HttpFailures {
    /**
     * Get empty error form server.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the boolean object if successful.
     */
    boolean getEmptyError() throws ErrorException, IOException;

    /**
     * Get empty error form server.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Boolean> getEmptyErrorAsync(final ServiceCallback<Boolean> serviceCallback);

    /**
     * Get empty error form server.
     *
     * @return the observable to the boolean object
     */
    Observable<Boolean> getEmptyErrorAsync();

    /**
     * Get empty error form server.
     *
     * @return the observable to the boolean object
     */
    Observable<ServiceResponse<Boolean>> getEmptyErrorWithServiceResponseAsync();

    /**
     * Get empty error form server.
     *
     * @throws ServiceException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the boolean object if successful.
     */
    boolean getNoModelError() throws ServiceException, IOException;

    /**
     * Get empty error form server.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Boolean> getNoModelErrorAsync(final ServiceCallback<Boolean> serviceCallback);

    /**
     * Get empty error form server.
     *
     * @return the observable to the boolean object
     */
    Observable<Boolean> getNoModelErrorAsync();

    /**
     * Get empty error form server.
     *
     * @return the observable to the boolean object
     */
    Observable<ServiceResponse<Boolean>> getNoModelErrorWithServiceResponseAsync();

    /**
     * Get empty response from server.
     *
     * @throws ServiceException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the boolean object if successful.
     */
    boolean getNoModelEmpty() throws ServiceException, IOException;

    /**
     * Get empty response from server.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Boolean> getNoModelEmptyAsync(final ServiceCallback<Boolean> serviceCallback);

    /**
     * Get empty response from server.
     *
     * @return the observable to the boolean object
     */
    Observable<Boolean> getNoModelEmptyAsync();

    /**
     * Get empty response from server.
     *
     * @return the observable to the boolean object
     */
    Observable<ServiceResponse<Boolean>> getNoModelEmptyWithServiceResponseAsync();

}
