/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the SimpleProduct class.
 * @constructor
 * The product documentation.
 *
 * @member {string} maxProductDisplayName Display name of product.
 * 
 * @member {string} [genericValue] Generic URL value.
 * 
 * @member {string} [odatavalue] URL value.
 * 
 */
function SimpleProduct() {
  SimpleProduct['super_'].call(this);
}

util.inherits(SimpleProduct, models['BaseProduct']);

/**
 * Defines the metadata of SimpleProduct
 *
 * @returns {object} metadata of SimpleProduct
 *
 */
SimpleProduct.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'SimpleProduct',
    type: {
      name: 'Composite',
      className: 'SimpleProduct',
      modelProperties: {
        productId: {
          required: true,
          serializedName: 'base_product_id',
          type: {
            name: 'String'
          }
        },
        description: {
          required: false,
          serializedName: 'base_product_description',
          type: {
            name: 'String'
          }
        },
        maxProductDisplayName: {
          required: true,
          serializedName: 'details.max_product_display_name',
          type: {
            name: 'String'
          }
        },
        capacity: {
          required: true,
          isConstant: true,
          serializedName: 'details.max_product_capacity',
          defaultValue: 'Large',
          type: {
            name: 'String'
          }
        },
        genericValue: {
          required: false,
          serializedName: 'details.max_product_image.generic_value',
          type: {
            name: 'String'
          }
        },
        odatavalue: {
          required: false,
          serializedName: 'details.max_product_image.@odata\\.value',
          type: {
            name: 'String'
          }
        }
      }
    }
  };
};

module.exports = SimpleProduct;
